artdaq Utilities - Bug #25320

When a critical artdaq process dies AND the trace script returns nonzero, DAQInterface hangs
Description

On December 6th, icarus' run 3894 hung for the following reason:

* A boardreader process died

¢ As expected, upon realizing this, DAQInterface entered the recover transition, designed to wind down the artdaqg processes as
cleanly as possible

¢ Since a trace script was meant to be executed on start, stop and recover (referred to by the DAQINTERFACE_TRACE_SCRIPT

variable), DAQInterface called it

For reasons irrelevant to this issue, the trace script returned nonzero, i.e., an error state

DAQInterface responded by throwing an exception which abruptly cancelled the recover transition and was uncaught

The next time (A) a critical process dies, and (B) the trace script returns in an error state, DAQInterface should continue winding
down cleanly.

Associated revisions

Revision 051abea6 - 12/14/2020 04:39 PM - John Freeman

JCF: Issue #25320: if a critical artdaq process dies and the trace script call returns nonzero, don't hang

History

#1 - 12/14/2020 04:43 PM - John Freeman
- % Done changed from 0 to 100

- Status changed from New to Resolved

Resolved with feature/25320_handle_process_death_and_trace_error (commit 051abea6c9289f54335f{36b940b4b7faccabaled)

#2 - 01/15/2021 01:44 PM - Wesley Ketchum
We've validated that this works in SBN-FD.

#3 - 01/15/2021 03:11 PM - John Freeman

- Status changed from Resolved to Reviewed
